unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, RegExpr, ExtCtrls, EditPlugAPI, EditPlugAPITypes,
  EditPlugFindUtils;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    bFind: TButton;
    cbWrap: TCheckBox;
    Panel2: TPanel;
    Label1: TLabel;
    Panel3: TPanel;
    edSearch: TMemo;
    cbRegex: TCheckBox;
    procedure bFindClick(Sender: TObject);
  private
    { Private declarations }
    procedure FindRegex(inputstring: string);
    procedure Find(inputstring: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  gPlugId: HINST;

implementation

{$R *.DFM}

{----- EXPORTS ----------------------------------------------------------------}

procedure plgSetId(id: HINST); cdecl;
begin
  gPlugId:= id;
end; exports plgSetId;

function plgShow: HWND; cdecl;
begin
  if not assigned(form1) then begin
    form1:= tform1.create(nil);
    epSetParentToMainWin(form1.handle);
    form1.show;
    epMoveWinToTopRight(form1);
  end else begin
    form1.show;
  end;
  result:= form1.Handle;
end; exports plgShow;

procedure plgWinFree; cdecl;
begin
  if assigned(form1) then begin
    form1.Free;
    form1:=nil;
  end;
end; exports plgWinFree;

function plgGetWinHandle: HWND; cdecl;
begin
  result:=0;
  if assigned(form1) then result:= form1.Handle;
end; exports plgGetWinHandle;

{------------------------------------------------------------------------------}

procedure NoMatch;
begin
  showmessage('Could not find match');
  epActiveEdRemoveSel;
end;

procedure TForm1.FindRegex(inputstring: string);
var
  endpos: integer;
  r: TRegExpr;
begin
  if edSearch.text = '' then exit;
  r := TRegExpr.Create;
  try
    inputstring := epGetActiveEdTextAsString;
    r.Expression := ProcessEscapeChars(edSearch.text);
    r.InputString := inputstring;
    if r.ExecPos(epGetActiveEdSelEnd+1) then begin
      epSetActiveEdSelStart(r.matchpos[0]-1);
      endpos:= r.matchpos[0] + r.MatchLen[0] -1;
      epSetActiveEdSelEnd(endpos);
    end else begin
      if cbWrap.checked then begin
        if r.Exec then begin
          epSetActiveEdSelStart(r.matchpos[0]-1);
          endpos:= r.matchpos[0] + r.MatchLen[0] -1;
          epSetActiveEdSelEnd(endpos);
        end else begin
          NoMatch;
        end;
      end else begin
        NoMatch;
      end;
    end;
  finally
    r.Free
  end;
end;

procedure TForm1.Find(inputstring: string);
var
  endpos: integer;
  position: dword;
begin
  position := NextPos(edSearch.text, inputstring, epGetActiveEdSelEnd+1);
  if position > 0 then begin
    epSetActiveEdSelStart(position-1);
    endpos:= position + length(edSearch.text) -1;
    epSetActiveEdSelEnd(endpos);
  end else begin
    if cbWrap.checked then begin
      position := NextPos(edSearch.text, inputstring);
      if position > 0 then begin
        epSetActiveEdSelStart(position-1);
        endpos:= position + length(edSearch.text) -1;
        epSetActiveEdSelEnd(endpos);
      end else begin
        NoMatch;
      end;
    end else begin
      NoMatch;
    end;
  end;
end;

procedure TForm1.bFindClick(Sender: TObject);
var inputstring: string;
begin
  if edSearch.text = '' then begin
    showmessage('Enter a search phrase');
    exit;
  end;
  inputstring := epGetActiveEdTextAsString;
  if inputstring = '' then begin
    showmessage('No input string available to search');
    exit;
  end;
  if cbRegex.checked then FindRegex(inputstring) else Find(inputstring);
end;

initialization

finalization

end.
